2 # Copyright (c) 2007, Nanako Shiraishi
4 dashless
=$
(basename "$0" |
sed -e 's/-/ /')
5 USAGE
="list [<options>]
6 or: $dashless show [<stash>]
7 or: $dashless drop [-q|--quiet] [<stash>]
8 or: $dashless ( pop | apply ) [--index] [-q|--quiet] [<stash>]
9 or: $dashless branch <branchname> [<stash>]
10 or: $dashless [save [--patch] [-k|--[no-]keep-index] [-q|--quiet]
11 [-u|--include-untracked] [-a|--all] [<message>]]
22 TMP
="$GIT_DIR/.git-stash.$$"
23 TMPindex
=${GIT_INDEX_FILE-"$GIT_DIR/index"}.stash.$$
24 trap 'rm -f "$TMP-"* "$TMPindex"' 0
28 if git config
--get-colorbool color.interactive
; then
29 help_color
="$(git config --get-color color.interactive.help 'red bold')"
30 reset_color
="$(git config --get-color '' reset)"
37 git diff-index
--quiet --cached HEAD
--ignore-submodules -- &&
38 git diff-files
--quiet --ignore-submodules &&
39 (test -z "$untracked" ||
test -z "$(untracked_files)")
43 excl_opt
=--exclude-standard
44 test "$untracked" = "all" && excl_opt
=
45 git ls-files
-o -z $excl_opt
51 die
"$(gettext "git stash
clear with parameters is unimplemented
")"
53 if current
=$
(git rev-parse
--verify $ref_stash 2>/dev
/null
)
55 git update-ref
-d $ref_stash $current
63 git update-index
-q --refresh
69 # state of the base commit
70 if b_commit
=$
(git rev-parse
--verify HEAD
)
72 head=$
(git rev-list
--oneline -n 1 HEAD
--)
74 die
"$(gettext "You
do not have the initial commit yet
")"
77 if branch
=$
(git symbolic-ref
-q HEAD
)
79 branch
=${branch#refs/heads/}
83 msg
=$
(printf '%s: %s' "$branch" "$head")
86 i_tree
=$
(git write-tree
) &&
87 i_commit
=$
(printf 'index on %s\n' "$msg" |
88 git commit-tree
$i_tree -p $b_commit) ||
89 die
"$(gettext "Cannot save the current index state
")"
91 if test -n "$untracked"
93 # Untracked files are stored by themselves in a parentless commit, for
94 # ease of unpacking later.
97 GIT_INDEX_FILE
="$TMPindex" &&
98 export GIT_INDEX_FILE
&&
100 git update-index
-z --add --remove --stdin &&
101 u_tree
=$
(git write-tree
) &&
102 printf 'untracked files on %s\n' "$msg" | git commit-tree
$u_tree &&
104 ) ) || die
"Cannot save the untracked files"
106 untracked_commit_option
="-p $u_commit";
108 untracked_commit_option
=
111 if test -z "$patch_mode"
114 # state of the working tree
116 git read-tree
--index-output="$TMPindex" -m $i_tree &&
117 GIT_INDEX_FILE
="$TMPindex" &&
118 export GIT_INDEX_FILE
&&
119 git
diff --name-only -z HEAD
-- >"$TMP-stagenames" &&
120 git update-index
-z --add --remove --stdin <"$TMP-stagenames" &&
124 die
"$(gettext "Cannot save the current worktree state
")"
128 rm -f "$TMP-index" &&
129 GIT_INDEX_FILE
="$TMP-index" git read-tree HEAD
&&
131 # find out what the user wants
132 GIT_INDEX_FILE
="$TMP-index" \
133 git add--interactive
--patch=stash
-- &&
135 # state of the working tree
136 w_tree
=$
(GIT_INDEX_FILE
="$TMP-index" git write-tree
) ||
137 die
"$(gettext "Cannot save the current worktree state
")"
139 git diff-tree
-p HEAD
$w_tree -- >"$TMP-patch" &&
140 test -s "$TMP-patch" ||
141 die
"$(gettext "No changes selected
")"
143 rm -f "$TMP-index" ||
144 die
"$(gettext "Cannot remove temporary index
(can
't happen)")"
149 if test -z "$stash_msg"
151 stash_msg=$(printf 'WIP on
%s
' "$msg")
153 stash_msg=$(printf 'On
%s
: %s
' "$branch" "$stash_msg")
155 w_commit=$(printf '%s
\n' "$stash_msg" |
156 git commit-tree $w_tree -p $b_commit -p $i_commit $untracked_commit_option) ||
157 die "$(gettext "Cannot record working tree state")"
178 die "$(eval_gettext "\"$dashless store\" requires one <commit> argument")"
181 if test -z "$stash_msg"
183 stash_msg="Created via \"git stash store\"."
186 # Make sure the reflog for stash is kept.
187 : >>"$GIT_DIR/logs/$ref_stash"
188 git update-ref -m "$stash_msg" $ref_stash $w_commit
190 test $ret != 0 && test -z $quiet &&
191 die "$(eval_gettext "Cannot update \$ref_stash with \$w_commit")"
210 # only default to keep if we don't already have an override
211 test -z "$keep_index" && keep_index
=t
216 -u|
--include-untracked)
228 # TRANSLATORS: $option is an invalid option, like
229 # `--blah-blah'. The 7 spaces at the beginning of the
230 # second line correspond to "error: ". So you should line
231 # up the second line with however many characters the
232 # translation of "error: " takes in your language. E.g. in
235 # $ git stash save --blah-blah 2>&1 | head -n 2
236 # error: unknown option for 'stash save': --blah-blah
237 # To provide a message, use git stash save -- '--blah-blah'
238 eval_gettextln
"error: unknown option for 'stash save': \$option
239 To provide a message, use git stash save -- '\$option'"
249 if test -n "$patch_mode" && test -n "$untracked"
251 die
"Can't use --patch and --include-untracked or --all at the same time"
256 git update-index
-q --refresh
259 say
"$(gettext "No
local changes to save
")"
262 test -f "$GIT_DIR/logs/$ref_stash" ||
263 clear_stash || die
"$(gettext "Cannot initialize stash
")"
265 create_stash
"$stash_msg" $untracked
266 store_stash
-m "$stash_msg" -q $w_commit ||
267 die
"$(gettext "Cannot save the current status
")"
268 say Saved working directory and index state
"$stash_msg"
270 if test -z "$patch_mode"
272 git
reset --hard ${GIT_QUIET:+-q}
273 test "$untracked" = "all" && CLEAN_X_OPTION
=-x || CLEAN_X_OPTION
=
274 if test -n "$untracked"
276 git clean
--force --quiet -d $CLEAN_X_OPTION
279 if test "$keep_index" = "t" && test -n $i_tree
281 git read-tree
--reset -u $i_tree
284 git apply
-R < "$TMP-patch" ||
285 die
"$(gettext "Cannot remove worktree changes
")"
287 if test "$keep_index" != "t"
295 git rev-parse
--verify $ref_stash >/dev
/null
2>&1
299 have_stash ||
return 0
300 git log
--format="%gd: %gs" -g --first-parent -m "$@" $ref_stash --
304 assert_stash_like
"$@"
306 git
diff ${FLAGS:---stat} $b_commit $w_commit
310 # Parses the remaining options looking for flags and
311 # at most one revision defaulting to ${ref_stash}@{0}
314 # Derives related tree and commit objects from the
315 # revision, if one is found.
317 # stash records the work tree, and is a merge between the
318 # base commit (first parent) and the index tree (second parent).
320 # REV is set to the symbolic version of the specified stash-like commit
321 # IS_STASH_LIKE is non-blank if ${REV} looks like a stash
322 # IS_STASH_REF is non-blank if the ${REV} looks like a stash ref
323 # s is set to the SHA1 of the stash commit
324 # w_commit is set to the commit containing the working tree
325 # b_commit is set to the base commit
326 # i_commit is set to the commit containing the index tree
327 # u_commit is set to the commit containing the untracked files tree
328 # w_tree is set to the working tree
329 # b_tree is set to the base tree
330 # i_tree is set to the index tree
331 # u_tree is set to the untracked files tree
333 # GIT_QUIET is set to t if -q is specified
334 # INDEX_OPTION is set to --index if --index is specified.
335 # FLAGS is set to the remaining flags
338 # * too many revisions specified
339 # * no revision is specified and there is no stash stack
340 # * a revision is specified which cannot be resolve to a SHA1
341 # * a non-existent stash reference is specified
344 parse_flags_and_rev
()
346 test "$PARSE_CACHE" = "$*" && return 0 # optimisation
362 REV
=$
(git rev-parse
--no-flags --symbolic --sq "$@") ||
exit 1
375 FLAGS
="${FLAGS}${FLAGS:+ }$opt"
384 have_stash || die
"$(gettext "No stash found.
")"
385 set -- ${ref_stash}@
{0}
391 die
"$(eval_gettext "Too many revisions specified
: \
$REV")"
395 REV
=$
(git rev-parse
--quiet --symbolic --verify "$1" 2>/dev
/null
) ||
{
397 die
"$(eval_gettext "\
$reference is not valid reference
")"
400 i_commit
=$
(git rev-parse
--quiet --verify "$REV^2" 2>/dev
/null
) &&
401 set -- $
(git rev-parse
"$REV" "$REV^1" "$REV:" "$REV^1:" "$REV^2:" 2>/dev
/null
) &&
409 test "$ref_stash" = "$(git rev-parse --symbolic-full-name "${REV%@*}")" &&
412 u_commit
=$
(git rev-parse
--quiet --verify "$REV^3" 2>/dev
/null
) &&
413 u_tree
=$
(git rev-parse
"$REV^3:" 2>/dev
/null
)
418 parse_flags_and_rev
"$@"
419 test -n "$IS_STASH_LIKE"
422 assert_stash_like
() {
423 is_stash_like
"$@" ||
{
425 die
"$(eval_gettext "'\$args' is not a stash-like commit
")"
430 is_stash_like
"$@" && test -n "$IS_STASH_REF"
434 is_stash_ref
"$@" ||
{
436 die
"$(eval_gettext "'\$args' is not a stash reference
")"
442 assert_stash_like
"$@"
444 git update-index
-q --refresh || die
"$(gettext "unable to refresh index
")"
446 # current index state
447 c_tree
=$
(git write-tree
) ||
448 die
"$(gettext "Cannot apply a stash
in the middle of a merge
")"
450 unstashed_index_tree
=
451 if test -n "$INDEX_OPTION" && test "$b_tree" != "$i_tree" &&
452 test "$c_tree" != "$i_tree"
454 git diff-tree
--binary $s^
2^..
$s^
2 | git apply
--cached
456 die
"$(gettext "Conflicts
in index. Try without
--index.
")"
457 unstashed_index_tree
=$
(git write-tree
) ||
458 die
"$(gettext "Could not save index tree
")"
464 GIT_INDEX_FILE
="$TMPindex" git-read-tree
"$u_tree" &&
465 GIT_INDEX_FILE
="$TMPindex" git checkout-index
--all &&
467 die
'Could not restore untracked files from stash'
471 GITHEAD_$w_tree='Stashed changes' &&
472 GITHEAD_$c_tree='Updated upstream' &&
473 GITHEAD_$b_tree='Version stash was based on' &&
474 export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
477 if test -n "$GIT_QUIET"
479 GIT_MERGE_VERBOSITY
=0 && export GIT_MERGE_VERBOSITY
481 if git merge-recursive
$b_tree -- $c_tree $w_tree
484 if test -n "$unstashed_index_tree"
486 git read-tree
"$unstashed_index_tree"
489 git diff-index
--cached --name-only --diff-filter=A
$c_tree >"$a" &&
490 git read-tree
--reset $c_tree &&
491 git update-index
--add --stdin <"$a" ||
492 die
"$(gettext "Cannot unstage modified files
")"
496 if test -n "$GIT_QUIET"
498 squelch
='>/dev/null 2>&1'
500 (cd "$START_DIR" && eval "git status $squelch") ||
:
502 # Merge conflict; keep the exit status from merge-recursive
505 if test -n "$INDEX_OPTION"
507 gettextln
"Index was not unstashed." >&2
514 assert_stash_ref
"$@"
521 say
"The stash is kept in case you need it again."
527 assert_stash_ref
"$@"
529 git reflog delete
--updateref --rewrite "${REV}" &&
530 say
"$(eval_gettext "Dropped \
${REV} (\
$s)")" ||
531 die
"$(eval_gettext "\
${REV}: Could not drop stash entry
")"
533 # clear_stash if we just dropped the last stash entry
534 git rev-parse
--verify "$ref_stash@{0}" >/dev
/null
2>&1 || clear_stash
538 test -n "$1" || die
"$(gettext "No branch name specified
")"
543 assert_stash_like
"$@"
545 git checkout
-b $branch $REV^
&&
546 apply_stash
"$@" && {
547 test -z "$IS_STASH_REF" || drop_stash
"$@"
551 PARSE_CACHE
='--not-parsed'
552 # The default command is "save" if nothing but options are given
558 *) seen_non_option
=t
; break ;;
562 test -n "$seen_non_option" ||
set "save" "$@"
588 create_stash
"$*" && echo "$w_commit"
610 say
"$(gettext "(To restore them
type \"git stash apply
\")")"